jQuery(document).ready(function($) {
	$('body').on('click', '.uplaunch_button', function(){
		var error = 0;
		var api_key = $(this).parent().find('[name="api_key"]').val();
		var journey_id = $(this).parent().find('[name="journey_id"]').val();
		var first_name = $(this).parent().find('[name="first_name"]').val();
		var last_name = $(this).parent().find('[name="last_name"]').val();
		var email = $(this).parent().find('[name="email"]').val();
		var phone = $(this).parent().find('[name="phone"]').val();
		var phone_required = $(this).parent().find('[name="phone"]').attr('required');

		var data = { journey_id: journey_id, contact: {first_name: first_name, last_name: last_name, email: email, phone: phone }, redirect: true };

		if ( first_name.length < 1 ) {
			error = 1;
			$field = $(this).parent().find('[name="first_name"]');
			indicateError($field, 'First name is required.');
		}
		if ( last_name.length < 1 ) {
			error = 1;
			$field = $(this).parent().find('[name="last_name"]');
			indicateError($field, 'Last name is required.');
		}
		if ( ! validateEmail(email) ) {
			error = 1;
			$field = $(this).parent().find('[name="email"]');
			indicateError($field, 'Invalid email address provided.');
		}

		if ( phone_required == 'required' && phone.length < 7 ) {
			error = 1;
			$field = $(this).parent().find('[name="phone"]');
			indicateError($field, 'Phone number is required.');
		}

		$('.uplaunch_input input').keyup(function(){
			$(this).removeClass('uplaunch-error');
		});

		if( error == 0 ) {
			$(this).text('Loading...');
			
			$.ajax({
				url: 'https://api.uplaunch.com/api/v1/new_lead_contacts',
				method: "POST",
				dataType: "json",
				crossDomain: true,
				contentType: "application/json; charset=utf-8",
				data: JSON.stringify(data),
				cache: false,
				beforeSend: function (xhr) {
					xhr.setRequestHeader("Authorization", api_key);
				},
				success: function (data) {
					window.location.href = data.redirect_url;
				},
				error: function (jqXHR, textStatus, errorThrown) {
					alert(errorThrown);
				}
			});
		}
	});
	
	function validateEmail(email) {
		var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
		return re.test(String(email).toLowerCase());
	}
	
	function indicateError($field, message) {
		$field.addClass('uplaunch-error').attr('placeholder', message);
	}
});